#!/bin/sh
-[ -n "$VCSH_DEBUG" ] && set -x
-[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
-[ -z "$VCSH_BASE" ] && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
+# This program is licensed under the GNU GPL version 2 or later.
+# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011
+# For details, see LICENSE. To submit patches, you have to agree to
+# license your code under the GNU GPL version 2 or later.
+
+
+[ -n "$VCSH_DEBUG" ] && set -vx
+[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
+[ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
+[ -n "$VCSH_DEBUG" ] && set -vx
+[ -z "$VCSH_REPO_D" ] && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
+[ -z "$VCSH_BASE" ] && VCSH_BASE="$HOME"
+[ -z "$VCSH_GITIGNORE" ] && VCSH_GITIGNORE='exact'
SELF=$(basename $0)
[<repo>] Clone from an existing repository
help Display this help text
delete Delete an existing repository
- enter Enter repository; spawn new $SHELL
+ enter Enter repository; spawn new instance of \$SHELL
init <repo> Initialize a new repository
list List all repositories
+ list-tracked List all files tracked by vcsh
+ list-tracked-by \\
+ <repo> List files tracked by a repository
rename <repo> \\
<newname> Rename repository
run <repo> \\
<command> Use this repository
-
- seed-gitignore \\
- <repo> Seed .gitignore.d/<repo> from git ls-files
setup Set up repository with recommended settings
+ write-gitignore \\
+ <repo> Write .gitignore.d/<repo> via git ls-files
- <repo> <git command> Special command that allows you to run git commands
- directly without having to type so much ;)" >&2
+ <repo> <git command> Shortcut to run git commands directly
+ <repo> Shortcut to enter repository" >&2
}
debug() {
git remote add origin "$GIT_REMOTE"
git config branch.master.remote origin
git config branch.master.merge refs/heads/master
+ if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
+ info "remote is empty, not merging anything"
+ exit
+ fi
git fetch
for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
[ -e "$object" ] &&
}
delete() {
- cd "$HOME" || fatal "could not enter '$HOME'" 11
+ cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
use
info "This operation WILL DETROY DATA!"
files=$(git ls-files)
init() {
[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
- export GIT_WORK_TREE="$HOME"
+ export GIT_WORK_TREE="$VCSH_BASE"
mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
git init
}
list() {
- for i in "$VCSH_BASE"/*.git; do
+ for i in "$VCSH_REPO_D"/*.git; do
echo $(basename "$i" .git)
done
}
-#get_files() {
-# return $(git ls-files)
-#}
-#
-#list_tracked_all() {
-# use
-# for repo in $(list); do
-# files="$files $(get_files $repo)"
-# done
-# echo $files | sort -u
-#}
+get_files() {
+ export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+ git ls-files
+}
+
+list_tracked() {
+ for VCSH_REPO_NAME in $(list); do
+ get_files
+ done | sort -u
+}
+
+list_tracked_by() {
+ use
+ git ls-files | sort -u
+}
rename() {
git_dir_exists
$VCSH_EXTERNAL_COMMAND
}
-seed_gitignore() {
+setup() {
+ use
+ git config core.worktree "$GIT_WORK_TREE"
+ git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+ git config vcsh.vcsh 'true'
+ [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
+}
+
+use() {
+ git_dir_exists
+ export GIT_WORK_TREE="$(git config --get core.worktree)"
+ export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
+
+write_gitignore() {
use
- cd "$HOME" || fatal "could not enter '$HOME'" 11
+ cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
gitignores=$(for file in $(git ls-files); do
while true; do
echo $file; new="${file%/*}"
echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
for gitignore in $gitignores; do
echo "$gitignore" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
- [ -d "$gitignore" ] && { echo "$gitignore/*" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
+ if [ x$VCSH_GITIGNORE = x'recursive' ] && [ -d "$gitignore" ]; then
+ { echo "$gitignore/*" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
+ fi
done
- if diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
+ if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
rm -f "$tempfile" || error "could not delete '$tempfile'"
exit
fi
- if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
- info "'$HOME/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'"
- mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
- fatal "could not move '$HOME/.gitignore.d/$VCSH_REPO_NAME' to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
+ if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
+ info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
+ mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+ fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
fi
- mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
- fatal "could not move '$tempfile' to '$HOME/.gitignore.d/$VCSH_REPO_NAME'" 53
-}
-
-setup() {
- use
- git config core.worktree "$GIT_WORK_TREE"
- git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
- git config vcsh.vcsh 'true'
- [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+ mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
+ fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
}
-use() {
- git_dir_exists
- export GIT_WORK_TREE="$(git config --get core.worktree)"
- export VCSH_DIRECTORY="$VCSH_REPO_NAME"
-}
+if [ ! x$VCSH_GITIGNORE = x'exact' ] && [ ! x$VCSH_GITIGNORE = x'recursive' ]; then
+ fatal "\$VCSH_GITIGNORE must be either 'exact' or 'recursive'" 1
+fi
if [ "$1" = 'clone' ]; then
[ -z $2 ] && fatal "$1: please specify a remote" 1
GIT_REMOTE="$2"
[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
export VCSH_REPO_NAME
- export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+ export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
elif [ "$1" = 'delete' ] ||
[ "$1" = 'enter' ] ||
[ "$1" = 'init' ] ||
- [ "$1" = 'list-tracked-all' ] ||
+ [ "$1" = 'list-tracked-by' ] ||
[ "$1" = 'rename' ] ||
[ "$1" = 'run' ] ||
- [ "$1" = 'seed-gitignore' ] ||
- [ "$1" = 'setup' ]; then
+ [ "$1" = 'setup' ] ||
+ [ "$1" = 'write-gitignore' ]; then
[ -z $2 ] && fatal "$1: please specify repository to work on" 1
[ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
[ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
export VCSH_COMMAND="$1"
export VCSH_REPO_NAME="$2"
- export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
- [ "$VCSH_COMMAND" = 'rename' ] && export GIT_DIR_NEW="$VCSH_BASE/$3.git"
- if [ "$VCSH_COMMAND" = 'run' ]; then
- shift 2
- export VCSH_EXTERNAL_COMMAND="$*"
- # Did we receive a directory instead of a name? Mangle the input to fit normal operation!
- if echo $VCSH_REPO_NAME | grep -q '/'; then
- export GIT_DIR=$VCSH_REPO_NAME
- export VCSH_REPO_NAME=$(basename $VCSH_REPO_NAME .git)
- fi
- fi
- [ "$VCSH_COMMAND" = 'seed-gitignore' ]
-elif [ "$1" = 'list' ]; then
+ export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+ [ "$VCSH_COMMAND" = 'rename' ] && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
+ [ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$*"
+ [ "$VCSH_COMMAND" = 'write-gitignore' ]
+elif [ "$1" = 'list' ] ||
+ [ "$1" = 'list-tracked' ]; then
export VCSH_COMMAND="$1"
-elif [ -n "$1" ]; then
- export VCSH_COMMAND=run
+elif [ -n "$2" ]; then
+ export VCSH_COMMAND='run'
export VCSH_REPO_NAME="$1"
- export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+ export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
[ -d $GIT_DIR ] || { help; exit 1; }
shift 1
export VCSH_EXTERNAL_COMMAND="git $*"
+elif [ -n "$1" ]; then
+ export VCSH_COMMAND='enter'
+ export VCSH_REPO_NAME="$1"
+ export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+ [ -d $GIT_DIR ] || { help; exit 1; }
else
# $1 is empty, or 'help'
help && exit
fi
-for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
+# Did we receive a directory instead of a name?
+# Mangle the input to fit normal operation.
+if echo $VCSH_REPO_NAME | grep -q '/'; then
+ export GIT_DIR=$VCSH_REPO_NAME
+ export VCSH_REPO_NAME=$(basename $VCSH_REPO_NAME .git)
+fi
+
+
+for check_directory in "$VCSH_REPO_D" "$VCSH_BASE/.gitignore.d"
do
if [ ! -d "$check_directory" ]; then
if [ -e "$check_directory" ]; then